import { BaseEntity, CreateDateColumn, UpdateDateColumn, ValueTransformer } from 'typeorm';
import * as moment from 'moment';

class CustomTimeTransformer implements ValueTransformer {
  to(): any {
    return moment().utcOffset(0).format('YYYY-MM-DD HH:mm:ss.SSS');
  }

  from(value: any): any {
    console.log('🚀 ~ from:', value);
    return value;
  }
}

export class BaseModel extends BaseEntity {
  @CreateDateColumn({
    type: 'char',
    length: 100,
    transformer: new CustomTimeTransformer(),
  })
  created_at: string;

  @UpdateDateColumn({
    type: 'char',
    length: 100,

    transformer: new CustomTimeTransformer(),
  })
  updated_at: string;

  @UpdateDateColumn({
    type: 'char',
    length: 100,

    transformer: new CustomTimeTransformer(),
  })
  timestamp: string;
}
